package com.gestionnaires;
/*
 * Remarque : Type de caractres utiliss dans ce fichier : UTF-8
 */

/**
 * Structure qui contient les param&egrave;tres d'une connexion.
 * @author 3fvorillion
 */
public class ParametresConnexion
{
	/*
	 * ATTRIBUTS
	 */
	/**
	 * Nom du serveur sur le r&eacute;seau.
	 */
	public String Serveur = "localhost";
	/**
	 * Num&eacute;ro du port du serveur auquel se connecter pour acc&eacute;der &agrave; la base.
	 */
	public String Port = "3306";
	/**
	 * Nom de la base de donn&eacute;es &agrave; utiliser.
	 */
	public String Base = "test";
	/**
	 * Login par d&eacute;faut de l'utilisateur habilit&eacute; sur la base de donn&eacute;es.
	 */
	public String Utilisateur = "root";
	/**
	 * Mot de passe par d&eacute;faut associ&eacute; au Login.
	 */
	public String Pwd = "";

	/**
	 * Mot de passe par d&eacute;faut associ&eacute; au Login.
	 */
	public String Url = "jdbc:mysql://localhost:3306/test";

	/**
	 * Classe qui correspond au pilote &agrave; utiliser pour se connecter &agrave; une base de donn&eacute;es.
	 */
	public static final String CLASSE = "com.mysql.jdbc.Driver";

	/*
	 * CONSTRUCTEURS
	 */
	/**
	 * Cr&eacute;er une instance de la classe avec les valeurs par d&eacute;faut des attributs.
	 */
	public ParametresConnexion() { ; }

	/**
	 * Cr&eacute;er une instance de la classe en copiant les valeurs d'une autre instance de cette classe.
	 * @param params Param&egrave;tres d&eacute;finits dans une autre instance de cette classe qui sont &agrave; recopier.
	 */
	public ParametresConnexion( ParametresConnexion params )
	{
		this.CopierDepuis(params);
	}

	/**
	 * Cr&eacute;er une instance de la classe en copiant les valeurs donn&eacute;es.
	 * @param serveur Nom du serveur sur le r&eacute;seau.
	 * @param port Num&eacute;ro du port du serveur auquel se connecter pour acc&eacute;der &agrave; la base.
	 * @param base Nom de la base de donn&eacute;es &agrave; utiliser.
	 * @param utilisateur Login par d&eacute;faut de l'utilisateur habilit&eacute; sur la base de donn&eacute;es.
	 * @param pwd Mot de passe par d&eacute;faut associ&eacute; au Login.
	 */
	public ParametresConnexion(String serveur, String port, String base, 
			String utilisateur, String pwd, String url)
	{
		this.Serveur = serveur;
		this.Port = port;
		this.Base = base;
		this.Utilisateur = utilisateur;
		this.Pwd = pwd;
		this.Url = url;
	}

	/*
	 * METHODES
	 */
	/**
	 * Copie les valeurs d'une autre instance de cette classe.
	 * @param params Param&egrave;tres d&eacute;finits dans une autre instance de cette classe qui sont &agrave; recopier.
	 */
	public void CopierDepuis( ParametresConnexion params )
	{
		this.Serveur = params.Serveur;
		this.Port = params.Port;
		this.Base = params.Base;
		this.Utilisateur = params.Utilisateur;
		this.Pwd = params.Pwd;
		this.Url = params.Url;
	}
}
