/*
 * ArticlesServlet.java
 *
 * Created on 11 janvier 2008, 15:06
 */

package com.servlets;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.Vector;
import com.articles.Article;
import com.articles.Categorie;
import com.gestionnaires.Erreur;
import com.gestionnaires.GestionnairePanier;
import java.sql.*;

/**
 * Servlet Grant l'affichage des articles de la BDD.<br>
 * - affichage, filtrage des articles et de leurs caractristiques.
 * @author 3fvorillion
 * @version
 */
public class ArticlesServlet
        extends HttpServlet
{
    com.gestionnaires.GestionnaireArticles gestArts = null;
    
    /**
     * Traite les messages et affiche en consquence.
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    private void affArticles(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
    {
    	String sPageAffichage = "";
    	Vector<Categorie> vCats = null;
    	Vector<Article> vArts = null;
    	String sIdCategAff;
    	String sCondReqSQL = "";

    	//
    	// Traite le filtre
    	//
    	sIdCategAff = request.getParameter("lstCategs");
    	if (sIdCategAff != null)
    	{
    		//Si pas dfinit ou "toutes catgorie"
	    	if (sIdCategAff.equals("") || sIdCategAff.equals("-1"))
	    	{
	    		sCondReqSQL = "";
	    	}
	    	else
	    	{
	    		sCondReqSQL = "CATEGORIE="+sIdCategAff;
	    	}
    	}
    	else
    		sCondReqSQL = "";

    	//Rcupre le gestionnaire d'articles
    	try
    	{
    		//
    		// Rcupre les articles depuis la base
    		//
    		this.gestArts = com.gestionnaires.GestionnaireArticles.getInstanceUnique();
    		
        	//Rcupre la liste des articles (filtrs)
        	vArts = this.gestArts.donnerListeArticles(sCondReqSQL);
        	//Rcupre la liste des articles
        	vCats = this.gestArts.donnerListeCategories("");
        	vCats.add(0, new Categorie(-1, "Toutes categories"));

        	if (!vArts.isEmpty())
        	{
    	        request.setAttribute("categories", vCats);
    	        request.setAttribute("articles", vArts);
    	        
    	        sPageAffichage = "/listeArticles.jsp";
        	}
        	else
        	{
    	        sPageAffichage = "/listeArticlesVide.jsp";
    		}

    	}
    	catch (Exception ex)
    	{
    		Vector<Erreur> vErrs = new Vector<Erreur>();
    		vErrs.add(new Erreur(ex.getMessage()));
	        request.setAttribute("erreurs", vErrs);
        
	        sPageAffichage = "/erreurs.jsp";
    	}
    	
        ServletContext ctx = getServletContext();
        RequestDispatcher rd = ctx.getRequestDispatcher(sPageAffichage);
        rd.forward(request,response);
    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
    	this.affArticles(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
    	this.affArticles(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Gestion de articles";
    }
    // </editor-fold>
}
