/*
 * Panier.java
 *
 * Created on 11 janvier 2008, 15:06
 */

package com.servlets;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.Vector;
import com.articles.Article;
import com.articles.Panier;
import com.articles.Client;
import com.gestionnaires.Erreur;
import com.gestionnaires.GestionnairePanier;

/**
 * Servlet Grant l'affichage des commandes d'un client.<br>
 * - payement et confirmation de payement.
 * @author 3fvorillion
 * @version
 */
public class ClientServlet
        extends HttpServlet
{
    com.gestionnaires.GestionnaireArticles gestArts = null;

    /**
     * Traite les messages et affiche en consquence.
     * @param request
     * @param response
     * @throws ServletException
     * @throws IOException
     */
    private void affPayement(HttpServletRequest request, HttpServletResponse response)
    	throws ServletException, IOException
    {
    	GestionnairePanier panier = null;
		Vector<Erreur> vErrs = new Vector<Erreur>();
    	Vector<Article> vArts = null;
    	Client cli = null;
    	String sAction;
    	String sPageAffichage;

    	//
    	// Rcupre l'objet de la session
    	//
    	panier = PanierServlet.getPanierSession(request);

    	//
    	// Traite les actions
    	//
    	sAction = request.getParameter("action");
    	if (sAction == null)
    	{ ; }
    	else if (sAction.equals("payer"))
    	{
    		cli = new Client();

    		//Rcupre les infos de l'utilisateur
    		if (request.getParameter("nomCli") != null)
    		{
    			if (!request.getParameter("nomCli").equals(""))
    				cli.setNom(request.getParameter("nomCli"));
    			else
    				vErrs.add(new Erreur("Votre nom n'est pas saisi."));
    		}
    		else
    			vErrs.add(new Erreur("Le nom du client n'est pas disponible."));
    		
    		if (request.getParameter("prenomCli") != null)
    		{
    			if (!request.getParameter("prenomCli").equals(""))
    				cli.setPrenom(request.getParameter("prenomCli"));
    			else
    				vErrs.add(new Erreur("Votre prenom n'est pas saisi."));
    		}
    		else
    			vErrs.add(new Erreur("Le prenom du client n'est pas disponible."));
    		
    		if (request.getParameter("addrCli") != null)
    		{
    			if (!request.getParameter("addrCli").equals(""))
    				cli.setAdresse(request.getParameter("addrCli"));
				else
					vErrs.add(new Erreur("Votre adresse n'est pas saisi."));
			}
			else
				vErrs.add(new Erreur("L'adresse du client n'est pas disponible."));
    		
    		if (request.getParameter("cpCli") != null)
    		{
    			if (!request.getParameter("cpCli").equals(""))
    				cli.setCodePost(request.getParameter("cpCli"));
				else
					vErrs.add(new Erreur("Votre code postal n'est pas saisi."));
			}
			else
				vErrs.add(new Erreur("Le code postal du client n'est pas disponible."));
    		
    		if (request.getParameter("villeCli") != null)
    		{
    			if (!request.getParameter("villeCli").equals(""))
    				cli.setVille(request.getParameter("villeCli"));
				else
					vErrs.add(new Erreur("Votre ville n'est pas saisi."));
			}
			else
				vErrs.add(new Erreur("La ville du client n'est pas disponible."));
	    	}

    	if (vErrs.isEmpty())
    	{
	    	//
	    	// Affiche la liste des articles du panier
	    	//
	    	//Rcupre la liste des articles
	    	vArts = panier.donneContenu();
	
	    	if (!vArts.isEmpty())
	    	{
		        request.setAttribute("articles", vArts);
		        request.setAttribute("panierTotal", new Panier(panier.getPrixTotalPanier()));
	
		        //Vrifie si on a dj saisi les infos client
		    	if (cli != null)
		    	{
			        request.setAttribute("client", cli);
	
		    		sPageAffichage = "/resultPayement.jsp";
		    		
		    		//Signale que le panier est prt  tre supprim
		    		panier.setEstPaye(true);
		    	}
		    	else
		    		sPageAffichage = "/payement.jsp";
	    	}
	    	else
	    	{
		        sPageAffichage = "/panierVide.jsp";
			}
    	}
    	else
    	{
            request.setAttribute("erreurs", vErrs);

            sPageAffichage = "/erreurs.jsp";
		}
    

        ServletContext ctx = getServletContext();
        RequestDispatcher rd = ctx.getRequestDispatcher(sPageAffichage);
        rd.forward(request,response);
    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
    	this.affPayement(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
    	this.affPayement(request, response);
    }

    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Gestion du client";
    }
    // </editor-fold>
}
